package krusty;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import spark.Request;
import spark.Response;

public class Database {
	/**
	 * Modify it to fit your environment and then use this string when connecting to your database!
	 */
	private static final String jdbcString = "jdbc:mysql://pusp.cs.lth.se:3306/iv4171bo";

	// For use with MySQL or PostgreSQL
	private static final String jdbcUsername = "iv4171bo";
	private static final String jdbcPassword = "i2qtnm8z";

	private Connection conn;

	public void connect() {
		// Connect to database here
		try {
        	// Connection strings for included DBMS clients:
        	// [MySQL]       jdbc:mysql://[host]/[database]
        	// [PostgreSQL]  jdbc:postgresql://[host]/[database]
        	// [SQLite]      jdbc:sqlite://[filepath]
        	
        	// Use "jdbc:mysql://puccini.cs.lth.se/" + userName if you using our shared server
        	// If outside, this statement will hang until timeout.
            conn = DriverManager.getConnection 
                (jdbcString, jdbcUsername, jdbcPassword);
        }
        catch (SQLException e) {
            System.err.println(e);
            e.printStackTrace();
        }
	}

	// TODO: Implement and change output in all methods below!

	public String getCustomers(Request req, Response res) {
		String query = "SELECT name, address FROM Customer";
		String title = "customers"; //ändra inte det är till för testet, söker efter just "customers" små bokstäver

		return getJson(query, title);
		
	}

	public String getRawMaterials(Request req, Response res) {
		String query = "SELECT ingredient_name as name, stock as amount, unit FROM Ingredient";
		String title = "raw-materials";
		
		return getJson(query, title);
	}

	public String getCookies(Request req, Response res) {
		String query = "Select name from Cookie";
		String title = "cookies";
		
		
		return getJson(query, title);
	}

	public String getRecipes(Request req, Response res) {
		String query = "Select r.cookie_name, i.ingredient_name, r.amount, i.unit From Ingredient i, Recipe r WHERE r.ingredient_name = i.ingredient_name;";
		String title = "recipes";
		
		return getJson(query, title);
	}

	public String getPallets(Request req, Response res) {
		String query = "Select cookie_name as cookie, blocked From Pallet;";
		String title = "pallets";
		return getJson(query, title);
	}

	public String reset(Request req, Response res) {
		return "{}";
	}

	public String createPallet(Request req, Response res) {
		if (req.queryParams("cookie") != null) {
			String cookie = req.queryParams("cookie");
			return createPallet(cookie);
		  } else {
			return "";
		  }
		}

		protected String createPallet(String cookie) {
			String query = "Insert into Pallet (manufacture_date, cookie_name) VALUES (NOW(), ?);";
			try (PreparedStatement stmt = conn.prepareStatement(query)) {
				stmt.setString(1, cookie);
				stmt.executeUpdate();
				removeMaterials(cookie);
			} catch (SQLException e) {
				return "bob";
			}
			return "";
		  }
		



	private String getJson(String query, String title) { //privat hjälpmetod så man slipper kalla på jsonizer varje gång
		try (PreparedStatement stmt = conn.prepareStatement(query)) {
			ResultSet rs = stmt.executeQuery();
			return Jsonizer.toJson(rs, title);
		} catch (SQLException e) {
			return "";
		}
	}
	public void removeMaterials(String cookie) { //privat hjälpmetod för att minska antalet material efter man gör en pallet
		String query = "Select ingredient_name, amount from Recipe where cookie_name = ?;";
		String query2 = "UPDATE Ingredient SET stock = stock - ? WHERE ingredient_name = ?;";

		try (PreparedStatement stmt = conn.prepareStatement(query)) {
			stmt.setString(1, cookie);
			ResultSet rs = stmt.executeQuery();
			while(rs.next()) { //loopar igenom och uppdaterar all material
				try (PreparedStatement stmt2 = conn.prepareStatement(query2)) {
					stmt2.setInt(1, rs.getInt("amount") * 54); //54 för (10*15*36)/100 = 10 kakor per låda, 15 lådor per box 36 boxar per pallet, materialet är för 100 kakor därför man delar allt med 100
					stmt2.setString(2, rs.getString("ingredient_name"));
					stmt2.executeUpdate();
				} catch (SQLException e) {
				}
			}
		} catch (SQLException e){
			//return false;
		}
		//return true;
	}
}
